//+------------------------------------------------------------------+
//|                                        #4X Bheurekso Pattern.mq4 |
//|                                                   Nikelodeon     |
//|                                                   mod STS 2013   |
//+------------------------------------------------------------------+
//#property copyright "Nikelodeon"
//#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 -1
#property indicator_width1 0

//---- input parameters
extern int history = 300;
extern int WidthArrows = 2;
extern int TextSize = 10;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   ObjectsDeleteAll(0,OBJ_TEXT);
   ObjectsDeleteAll(0,OBJ_ARROW);
   
   return(0);

  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectsDeleteAll(0,OBJ_TEXT);
   ObjectsDeleteAll(0,OBJ_ARROW);

   return(0);
  }

void SetArrowUp(int sh, datetime tm, double pr, int cod, color clr, int wdth)
{
	ObjectCreate("Arrow-"+sh,OBJ_ARROW,0,tm,pr);
	ObjectSet("Arrow-"+sh,OBJPROP_ARROWCODE,cod);
	ObjectSet("Arrow-"+sh,OBJPROP_COLOR,clr);
	ObjectSet("Arrow-"+sh,OBJPROP_WIDTH,wdth);
}
void SetArrowDn(int sh, datetime tm, double pr, int cod, color clr, int wdth)
{
	ObjectCreate("Arrow+"+sh,OBJ_ARROW,0,tm,pr);
	ObjectSet("Arrow+"+sh,OBJPROP_ARROWCODE,cod);
	ObjectSet("Arrow+"+sh,OBJPROP_COLOR,clr);
	ObjectSet("Arrow+"+sh,OBJPROP_WIDTH,wdth);
}

void SetTextUp(int sh, datetime tm, double pr, string text, color clr, int fse)
{
	ObjectCreate("x"+sh,OBJ_TEXT,0,tm,pr);
	ObjectSetText("x"+sh,text);
	ObjectSet("x"+sh,OBJPROP_COLOR,clr);
	ObjectSet("x"+sh,OBJPROP_FONTSIZE,fse);
}
void SetTextDn(int sh, datetime tm, double pr, string text, color clr, int fse)
{
	ObjectCreate("y"+sh,OBJ_TEXT,0,tm,pr);
	ObjectSetText("y"+sh,text);
	ObjectSet("y"+sh,OBJPROP_COLOR,clr);
	ObjectSet("y"+sh,OBJPROP_FONTSIZE,fse);
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
	int shift1=0, shift2=0, shift3=0;
	bool BullEngulf=False, MorningStar=False, BullPierce=False, Hammer=False,NameUp=false,ArrowUp=false;
	bool BearEngulf=False, EveningStar=False, DarkCloud=False, Shooter=False,NameDn=false,ArrowDn=false;
	bool BullHarami=False, BearHarami=false, BullCross=false, BearCross=false,up=false,down=false; 
	int n,a,b,x; 
  	double l[1000],h[1000];
   	
	for (int shift=history; shift>=0; shift--) 
	{
	  shift1=shift+1;
	  shift2=shift+2;
	  shift3=shift+3;

		if ((iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift)>iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift1)) &&
		   (iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift1)>iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift2)) &&
		   (iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift2)>iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift3)))
		  up=true;
		 else up=false;
		 
		if ((iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift)<iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift1)) &&
		   (iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift1)<iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift2)) &&
		   (iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift2)<iMA(NULL,0,5,0,MODE_EMA,PRICE_CLOSE,shift3)))
		  down=true;
		 else down=false;

      if (5==Period()){a=15; b=5;}
      if (15==Period()){a=7; b=3;}
      if (60==Period()){a=25; b=15;}
      if (240==Period()){a=30; b=20;}
      if (1440==Period()){a=35; b=25;}
      
		if ((down)&&(Open[shift2]>Close[shift2]) && (Open[shift1]>Close[shift2]) && (Close[shift1]<Open[shift2]) && (Close[shift1]>Open[shift1]))
		   BullHarami=true;
		  else
		   BullHarami=false;
		
		if ((Open[shift2]>Close[shift2]) && (Open[shift1]>Close[shift2])&& (Open[shift1]<Open[shift2])&& (Close[shift1]>Open[shift2]))
		   BullCross=true;
		  else
		   BullCross=false;
		   
		//--- Bullish Engulfing (2 bars)
		if ((Close[shift2]<Open[shift2]) && (Open[shift1]<Close[shift2]) && (Close[shift1]>Open[shift2])) 
			BullEngulf=true;
		  else 
			BullEngulf=false;
		
		//--- Bullish Piercing (2 bars)
		if (!BullEngulf)
		 {
			if ((Close[shift2]<Open[shift2]) && (Close[shift1]>Open[shift1]) && ((Open[shift1]<Close[shift2])) && (Close[shift1]>Close[shift2]+((Open[shift2]-Close[shift2])/2))) 
				BullPierce=true;
			 else 
				BullPierce=false;
		 }
		 else 
			BullPierce=false;
		
		// Morning Star (3 bars)
		if ((Close[shift3]<Open[shift3]) && (Open[shift2]<Close[shift3]) && (Close[shift2]<Close[shift3]) && ((Open[shift1]>Close[shift2]) && (Open[shift1]>Open[shift2])) && (Close[shift1]>=Close[shift3]))
			MorningStar=true;
		 else
			MorningStar=false;
		
		// Hammer
		if ((Open[shift1]-Low[shift1]>MathMax(High[shift1]-Close[shift1],Close[shift1]-Open[shift1])*3) && (Close[shift1]-Low[shift1]>MathMax(High[shift1]-Close[shift1],Close[shift1]-Open[shift1])*3))
			Hammer=true;
		 else 
		 	Hammer=false;
		
		if ((up)&&(Open[shift2]<Close[shift2]) && (Open[shift1]<Close[shift2]) && (Close[shift1]>Open[shift2]) && (Close[shift1]<Open[shift1]))
		      BearHarami=true;
		 else
		   BearHarami=false;
		
		if ((Open[shift2]<Close[shift2]) && (Open[shift1]<Close[shift2])&&(Open[shift1]>Open[shift2])&& (Close[shift1]<Open[shift2]))
		   BearCross=true;
		  else
		    BearCross=false;

		//--- Bearish Engulfing (2 bars)
		if ((Close[shift2]>Open[shift2]) && (Close[shift1]<Open[shift1]) && (Open[shift1]>Close[shift2]) &&	((Close[shift1]<Open[shift2]) ))
			BearEngulf=true;
		 else
			BearEngulf=false;
		
		//--- Bearish Dark Cloud (2 bars)
		if(!BearEngulf)
		 {
			if ((Close[shift2]>Open[shift2]) && ((Open[shift1]>Close[shift2])) && (Close[shift1]<Close[shift2]-((Close[shift2]-Open[shift2])/2)))
				DarkCloud=true;
			 else 
				DarkCloud=false;
		 }
		 else 
			DarkCloud=false;
		
		// Evening Star (3 bars)
		if ((Close[shift3]>Open[shift3]) && (Open[shift2]>Close[shift3]) && (Close[shift2]>Close[shift3]) && ((Open[shift1]<Close[shift2]) && (Open[shift1]<Open[shift2])) && (Close[shift1]<Close[shift3]))
			EveningStar=true;
		 else 
			EveningStar=false;
		
		// Shooting Star 
		if ((up)&&(High[shift1]-Open[shift1]>MathMax(Close[shift1]-Low[shift1],Open[shift1]-Close[shift1])*3) && (High[shift1]-Close[shift1]>MathMax(Close[shift1]-Low[shift1],Open[shift1]-Close[shift1])*3)) 
			Shooter=true;
		 else
			Shooter=false;
			
			if ((BullEngulf || BullPierce || MorningStar || BullHarami || BullCross) && (Close[shift]>Close[shift1])&& Close[shift]>Open[shift1])
			{
			 NameUp=true;
			 ArrowUp=true;
			}
		  else 
			{NameUp=false; ArrowUp=false;}

		if ((BearEngulf || DarkCloud || EveningStar || Shooter || BearHarami || BearCross) && (Close[shift]<Close[shift1])&& Close[shift]<Open[shift1])
		  {
			NameDn=true;
			ArrowDn=true;
			}
		 else 
			{NameDn=false; ArrowDn=false;}
			
         if (Hammer)
         { 
           if (down) {NameUp=true; ArrowUp=true;}
            else {NameUp=false; ArrowUp=false;}
            
           if (up) {NameDn=true; ArrowDn=true;}
            else {NameDn=false; ArrowDn=false;}
          }

		if (BullHarami)
		 {
			if (NameUp) {n++; l[n]=Low[shift1]; SetTextUp(n,Time[shift1],Low[shift1]-a*Point,"Bull Harami",Lime,TextSize);}
			if (ArrowUp) SetArrowUp(n,Time[shift1],Low[shift1]-b*Point,241,DarkOrange,WidthArrows);
		 }

		if (BullCross)
		 {
			if (NameUp) {n++; SetTextUp(n,Time[shift1],Low[shift1]-a*Point,"Bull Cross",Lime,TextSize); l[n]=Low[shift1];}
			if (ArrowUp) SetArrowUp(n,Time[shift1],Low[shift1]-b*Point,241,LimeGreen,WidthArrows);
		 }

		if (BullEngulf)
		 {
			if (NameUp) {n++; l[n]=Low[shift1]; SetTextUp(n,Time[shift1],Low[shift1]-a*Point,"Bullish Engulfing",Lime,TextSize);}
			if (ArrowUp) SetArrowUp(n,Time[shift1],Low[shift1]-b*Point,241,Magenta,WidthArrows);
		 }
		
		if (BullPierce)
		 {
			if (NameUp) {n++; l[n]=Low[shift1]; SetTextUp(n,Time[shift1],Low[shift1]-a*Point,"Bullish Piercing",Lime,TextSize);}
			if (ArrowUp) SetArrowUp(n,Time[shift1],Low[shift1]-b*Point,241,DarkOrange,WidthArrows);
		 }
		
		if (MorningStar)
		 {
			if (NameUp) {n++; SetTextUp(n,Time[shift2],Low[shift2]-a*Point,"Morning Star",Lime,TextSize); l[n]=Low[shift2];}
			if (ArrowUp) SetArrowUp(n,Time[shift2],Low[shift2]-b*Point,241,Magenta,WidthArrows);
		 }
		
		if (Hammer)
		 {
			if (NameUp) {n++; SetTextUp(n,Time[shift1],Low[shift1]-a*Point,"Hammer",Lime,TextSize); l[n]=Low[shift1];}
			if (ArrowUp) SetArrowUp(n,Time[shift1],Low[shift1]-b*Point,241,DarkOrange,WidthArrows);
		 }

		if (BearHarami)
		 {
			if (NameDn) {x++; h[x]=High[shift1]; SetTextDn(x,Time[shift1],High[shift1]+(15+a)*Point,"Bear Harami",SandyBrown,TextSize);}
			if (ArrowDn) SetArrowDn(x,Time[shift1],High[shift1]+(10+b)*Point,242,DarkOrange,WidthArrows);
		 }
		
		if (BearCross)
		 {
			if (NameDn) {x++; SetTextDn(x,Time[shift1],High[shift1]+(15+a)*Point,"Bear Cross",SandyBrown,TextSize); h[x]=High[shift1];}
			if (ArrowDn) SetArrowDn(x,Time[shift1],High[shift1]+(10+b)*Point,242,LimeGreen,WidthArrows);
		 }
		
		if (Hammer)
		 {
			if (NameDn) {x++; SetTextDn(x,Time[shift1],High[shift1]+(15+a)*Point,"Hammer",Lime,TextSize); h[x]=High[shift1];}
			if (ArrowDn) SetArrowDn(x,Time[shift1],High[shift1]+(10+b)*Point,242,DarkOrange,WidthArrows);
		 }
		
		if (BearEngulf)
		 {
			if (NameDn) {x++; h[x]=High[shift1]; SetTextDn(x,Time[shift1],High[shift1]+(15+a)*Point,"Bearish Engulfing",SandyBrown,TextSize);}
			if (ArrowDn) SetArrowDn(x,Time[shift1],High[shift1]+(10+b)*Point,242,Blue,WidthArrows);
		 }
		
		if (DarkCloud)
		 {
			if (NameDn) {x++; h[x]=High[shift1]; SetTextDn(x,Time[shift1],High[shift1]+(15+a)*Point,"Dark Cloud",SandyBrown,TextSize);}
			if (ArrowDn) SetArrowDn(x,Time[shift1],High[shift1]+(10+b)*Point,242,DarkOrange,WidthArrows);
		 }

		if (EveningStar)
		 {
			if (NameDn) {x++; h[x]=High[shift2]; SetTextDn(x,Time[shift2],High[shift2]+(15+a)*Point,"Evening Star",SandyBrown,TextSize);}
			if (ArrowDn) SetArrowDn(x,Time[shift2],High[shift2]+(10+b)*Point,242,Magenta,WidthArrows);
		 }
		
		if (Shooter)
		 {
			if (NameDn) {x++; SetTextDn(x,Time[shift1],High[shift1]+(15+a)*Point,"Shooting Star",SandyBrown,TextSize); h[x]=High[shift1];}
			if (ArrowDn) SetArrowDn(x,Time[shift1],High[shift1]+(10+b)*Point,242,OrangeRed,WidthArrows);
		 }
   }

   return(0);
}